var FunctionRegistrator = Class.extend({
	init: function() {
		this.map = {names: [], functions: [], thisArgs: []};
	},
	
	register: function(func, name, thisArg) {
		var thisArg = (typeof thisArg === "undefined") ? null : thisArg;

		var i = this.map.names.indexOf(name);
		
		if (i > -1) {
			this.map.functions[i] = func;
			this.map.thisArgs[i] = thisArg;
		} else {
			this.map.functions.push(func);
			this.map.names.push(name);
			this.map.thisArgs.push(thisArg);
		}
	},
	
	exec: function(name, args) {
		var idx = this.map.names.indexOf(name);
		
		if (idx > -1) {
			return this.map.functions[idx].apply(this.map.thisArgs[idx], args);
		} else {
			console.log("No function named " + name + " is registered in FunctionRegistrator.");
			//throw "No function named " + name + " is registered in FunctionRegistrator.";
		}
	}
});
